////////////////////////////////////////////////////////////////
// 電卓ガジェット
//   Copyright (C) 2008 - 2012 AAOh inc.
////////////////////////////////////////////////////////////////

/**
 * @fileOverview 電卓ガジェット
 * @author       $Author: fujishiro $
 */

(function () {
/**
 * calc。
 *
 * @namespace
 */
calc = {
}
})();

(function () {
/**
 * Control。
 *
 * @constructor
 */
calc.Control = aaoh.kaze.Gadget.extend(
	aaoh.sora.ControlEx, function() {
	// Application名。
	this.APP_NAME    = 'calc';
	this.APP_VERSION = '2.6.0';

	// Windowサイズ。
	this.WINDOW_ONDOCK_WIDTH         = 130 +  0;
	this.WINDOW_ONDOCK_HEIGHT        = 148 + 12;
	this.WINDOW_UNDOCK_WIDTH         = 180 +  0;
	this.WINDOW_UNDOCK_HEIGHT        = 195 + 12;
	this.WINDOW_ONDOCK_MOBILE_WIDTH  = this.WINDOW_ONDOCK_WIDTH;
	this.WINDOW_ONDOCK_MOBILE_HEIGHT = this.WINDOW_ONDOCK_HEIGHT;
	this.WINDOW_UNDOCK_MOBILE_WIDTH  = this.WINDOW_ONDOCK_MOBILE_WIDTH;
	this.WINDOW_UNDOCK_MOBILE_HEIGHT = this.WINDOW_ONDOCK_MOBILE_HEIGHT;
	this.WINDOW_OPTION_WIDTH         = 250 +  0;
	this.WINDOW_OPTION_HEIGHT        = 300 + 12;
	this.WINDOW_OPTION_MOBILE_WIDTH  = 230 +  0;
	this.WINDOW_OPTION_MOBILE_HEIGHT = 160 + 12;

	// デフォルト値
	this.MAX_POSITIVE_LENGTH = 9; // 有効桁数
	this.MAX_NEGATIVE_LENGTH = 5;

	// sound
	this.sound = new aaoh.kaze.Sound();

	// copyright
	this.LST_IMG_NM.push('imgCopilot');
	this.LST_LNK_NM.push('lnkCopilot');
	this.LST_URL['imgCopilot'] = 'http://copilot.jp/';
	this.LST_URL['lnkCopilot'] = 'http://copilot.jp/';
})
})();

(function () {
/**
 * Model。
 *
 * @constructor
 */
calc.Model = aaoh.kaze.Gadget.extend(
	aaoh.sora.ModelEx, function() {
	this.data.type    = '1';
	this.data.isComma = true;
});
	/**
	 * 設定情報の読込み(iGoogle)。
	 */
	calc.Model.prototype.
	readDataForIGoogle = function() {
		var type    = aaoh.sora.App.control.storage.readString('type');
		var isComma = aaoh.sora.App.control.storage.readString('isComma');

		if (type != null) {
			this.data.type  = type;
		}
		this.data.isComma = isComma;
	}

	/**
	 * 設定情報の書込み(iGoogle)。
	 */
	calc.Model.prototype.
	writeDataForIGoogle = function() {
		aaoh.sora.App.control.storage.writeString(
			'type', this.data.type
		);
		aaoh.sora.App.control.storage.writeString(
			'isComma', this.data.isComma
		);
	}
})();

(function () {
/**
 * App。
 *
 * @namespace
 */
aaoh.sora.App = {
	control: new calc.Control(),
	model:   new calc.Model(),
	main:    null,
	option:  null,

	/**
	 * 初期化。
	 *
	 * @param {String} target 初期化するターゲット
	 */
	init: function(target) {
		if (
			target != null && target == aaoh.sora.App.control.MAIN_NM
		) {
			aaoh.sora.App.main   = new calc.Main();
			aaoh.sora.App.option = null;

		} else if (
			target != null && target == aaoh.sora.App.control.OPTION_NM
		) {
			aaoh.sora.App.main   = null;
			aaoh.sora.App.option = new calc.Option();

		} else {
			aaoh.sora.App.main   = new calc.Main();
			aaoh.sora.App.option = new calc.Option();
		}

		// バージョンチェックを行う
		aaoh.sora.App.control.FLG_UPDATE = true;

		aaoh.sora.App.control.init();
	}
}
})();
